<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\FPA;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;

class EsoConsumer extends \Doctrine\ORM\EntityRepository {
    
    const IDSITUACAO_PENDENTE  = 'PENDENTE';
	const IDSITUACAO_ANDAMENTO = 'ANDAMENTO';
	const IDSITUACAO_CONCLUIDO = 'CONCLUIDO';
    
    public function retornaConsumer($nrorg, $nrconsumer){
        try{
            $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
            $sql = "SELECT *
                      FROM ESO_CONSUMER
                     WHERE NRORG = :P_NRORG
                       AND NRCONSUMER = :P_NRCONSUMER";
            $params = array(
                'P_NRORG' => $nrorg,
                'P_NRCONSUMER' => $nrconsumer
            );
            return $resultado = $db->fetchAll($sql,$params);
        } catch (Exception $e) {
            throw $e;
        }
    }

	public function addPidprocess($nrorg, $nrconsumer, $pid) {
	    $dthratual = DateUtil::getDataAtual();
	    
		$sql = "UPDATE ESO_CONSUMER 
				   SET DSPIDPROCESSO = DECODE(DSPIDPROCESSO, NULL, TO_CHAR($pid), DSPIDPROCESSO || ',' || TO_CHAR($pid)),
				       IDSITUACAO = DECODE(IDSITUACAO, 'PENDENTE', 'ANDAMENTO', IDSITUACAO),
				       DTHRINICIO = DECODE(IDSITUACAO, 'PENDENTE', '$dthratual', DTHRINICIO),
				       DTULTATU = '$dthratual'
				 WHERE NRORG = $nrorg 
				   AND NRCONSUMER = $nrconsumer";

        \Setforms2\Shared\Registry::getEntityManagerConnection()->exec($sql);
	}


	public function addDthrinicio($nrorg, $nrconsumer) {
	    $dthratual = DateUtil::getDataAtual();
	    
		$sql = "UPDATE ESO_CONSUMER 
				   SET IDSITUACAO = DECODE(IDSITUACAO, 'PENDENTE', 'ANDAMENTO', IDSITUACAO),
				       DTHRINICIO = DECODE(IDSITUACAO, 'PENDENTE', '$dthratual', DTHRINICIO),
				       DTULTATU = '$dthratual'
				 WHERE NRORG = $nrorg 
				   AND NRCONSUMER = $nrconsumer";

        \Setforms2\Shared\Registry::getEntityManagerConnection()->exec($sql);
	}

	public function addNrtotprocess($nrorg, $nrconsumer, $qtdenvios) {
		$sql = "UPDATE ESO_CONSUMER 
				   SET NRTOTPROCESS = NVL(NRTOTPROCESS, 0) + $qtdenvios
				 WHERE NRORG = $nrorg 
				   AND NRCONSUMER = $nrconsumer";

        \Setforms2\Shared\Registry::getEntityManagerConnection()->exec($sql);
        
        $dthratual = DateUtil::getDataAtual();
        
        $sql = "UPDATE ESO_CONSUMER 
				   SET IDSITUACAO = DECODE(NRTOTPROCESS, NRTOTENVIOS, 'CONCLUIDO', 'ANDAMENTO'),
				       DTHRFIM = DECODE(NRTOTPROCESS, NRTOTENVIOS, '$dthratual', DTHRFIM)
				 WHERE NRORG = $nrorg 
				   AND NRCONSUMER = $nrconsumer";

        \Setforms2\Shared\Registry::getEntityManagerConnection()->exec($sql);
	}

	public function clearLoteEsocadastro($nrorg, $nrlote) {
		$sql = "UPDATE ESO_CADASTRO 
				   SET NRLOTE = NULL
				 WHERE NRORG = $nrorg 
				   AND NRLOTE = $nrlote";

        \Setforms2\Shared\Registry::getEntityManagerConnection()->exec($sql);
	}

	public function clearLoteEsonaoperiodico($nrorg, $nrlote) {
		$sql = "UPDATE ESO_NAOPERIODICO 
				   SET NRLOTE = NULL
				 WHERE NRORG = $nrorg 
				   AND NRLOTE = $nrlote";

        \Setforms2\Shared\Registry::getEntityManagerConnection()->exec($sql);
	}

	public function clearLoteEsoperiodico($nrorg, $nrlote) {
		$sql = "UPDATE ESO_PERIODICO 
				   SET NRLOTE = NULL
				 WHERE NRORG = $nrorg 
				   AND NRLOTE = $nrlote";

        \Setforms2\Shared\Registry::getEntityManagerConnection()->exec($sql);
	}
    
    public function insertEsoConsumer($nrorg, $dsparams, $nrtotenvios) {
        $consumer = new \Teknisa\Model\Gestaopessoas\Entities\EsoConsumer();
        $nrconsumer = \HCM\Util\NovoCodigo::geraCodigo(0, 'ESO_CONSUMER', 1, 20, true);

        \Setforms2\Shared\Registry::getEntityManager()->beginTransaction();
        
        try {
            $consumer->setNrconsumer($nrconsumer);
            $consumer->setNrorg($nrorg);
            $consumer->setDsparams($dsparams);
            $consumer->setNrtotenvios($nrtotenvios);
            $consumer->setNrtotprocess(0);
            $consumer->setIdsituacao(self::IDSITUACAO_PENDENTE);
            $consumer->setDtinclusao(DateUtil::getDataAtual());
            $consumer->setCdoperinclusao(FPA::getCdoperador());
            $consumer->setNrorginclusao($nrorg);
            
            \Setforms2\Shared\Registry::getEntityManager()->persist($consumer);
            \Setforms2\Shared\Registry::getEntityManager()->flush();
            \Setforms2\Shared\Registry::getEntityManager()->commit();
        } catch(\Exception $e) {
            \Setforms2\Shared\Registry::getEntityManager()->rollback();
            throw new \Exception($e->getMessage());
        }

        return $consumer;
    }
    
}